unit FARIntf;

interface

{$ALIGN OFF}  // !
{$MINENUMSIZE 4}

uses
  Windows,

  FARLang;

const
  NM                           = 260;

  //  OPENPLUGININFO_FLAGS
  OPIF_USEFILTER               = $0001;
  OPIF_USESORTGROUPS           = $0002;
  OPIF_USEHIGHLIGHTING         = $0004;
  OPIF_ADDDOTS                 = $0008;
  OPIF_RAWSELECTION            = $0010;
  OPIF_REALNAMES               = $0020;
  OPIF_SHOWNAMESONLY           = $0040;
  OPIF_SHOWRIGHTALIGNNAMES     = $0080;
  OPIF_SHOWPRESERVECASE        = $0100;
  OPIF_FINDFOLDERS             = $0200;
  OPIF_COMPAREFATTIME          = $0400;
  OPIF_EXTERNALGET             = $0800;
  OPIF_EXTERNALPUT             = $1000;
  OPIF_EXTERNALDELETE          = $2000;
  OPIF_EXTERNALMKDIR           = $4000;

  //  TPluginPanelItem.Flags
  PPIF_PROCESSDESCR = $80000000;
  PPIF_CREATEDBYPLUGIN = 1; 

type
  OPENPLUGININFO_SORTMODES = (
    SM_DEFAULT,SM_UNSORTED,SM_NAME,SM_EXT,SM_MTIME,SM_CTIME,
    SM_ATIME,SM_SIZE,SM_DESCR,SM_OWNER
  );
  FCTL = (
    FCTL_CLOSEPLUGIN, FCTL_GETPANELINFO, FCTL_GETANOTHERPANELINFO,
    FCTL_UPDATEPANEL, FCTL_UPDATEANOTHERPANEL,
    FCTL_REDRAWPANEL, FCTL_REDRAWANOTHERPANEL,
    FCTL_SETANOTHERPANELDIR,
    //
    FCTL_GETCMDLINE,FCTL_SETCMDLINE,
    FCTL_SETSELECTION,FCTL_SETANOTHERSELECTION,
    FCTL_SETVIEWMODE,FCTL_SETANOTHERVIEWMODE,FCTL_INSERTCMDLINE,
    FCTL_SETUSERSCREEN);

  FE = (
    FE_CHANGEVIEWMODE,
    FE_REDRAW,
    FE_IDLE,
    FE_CLOSE);
    
  PLUGIN_FLAGS = (
    PF_0,
    PF_PRELOAD);

  OPEN = (
    OPEN_DISKMENU,
    OPEN_PLUGINSMENU,
    OPEN_FINDLIST);

const
    PKF_NONE = 0;
    PKF_CONTROL = 1;
    PKF_ALT = 2;
    PKF_SHIFT = 4;

const //OPERATION_MODES
    OPM_NORMAL = 0;
    OPM_SILENT = 1;
    OPM_FIND = 2;
    OPM_VIEW = 4;
    OPM_EDIT = 8;

type
  PPCharArray = ^TPCharArray;
  TPCharArray = array[0..0] of PChar;
  
  TIntegerArray = array[0..0] of Integer;

  TPluginInfo = record
    StructSize: Integer;
    Flags: PLUGIN_FLAGS;
    DiskMenuStrings: PPCharArray;
    DiskMenuNumbers: ^TIntegerArray;
    DiskMenuStringsNumber: Integer;
    PluginMenuStrings: PPCharArray;
    PluginMenuStringsNumber: Integer;
    PluginConfigStrings: PPCharArray;
    PluginConfigStringsNumber: Integer;
  end;

const
  DIF_NONE            =      0;
  DIF_COLORMASK       =    $ff;
  DIF_SETCOLOR        =   $100;
  DIF_BOXCOLOR        =   $200;
  DIF_GROUP           =   $400;
  DIF_LEFTTEXT        =   $800;
  DIF_MOVESELECT      =  $1000;
  DIF_SHOWAMPERSAND   =  $2000;
  DIF_CENTERGROUP     =  $4000;
  DIF_NOBRACKETS      =  $8000;
  DIF_SEPARATOR       = $10000;
  DIF_EDITOR          = $20000;
  DIF_HISTORY         = $40000;

  FMENU_SHOWAMPERSAND=1;
  FMENU_WRAPMODE=2;
  FMENU_AUTOHIGHLIGHT=4;
  FMENU_REVERSEAUTOHIGHLIGHT=8;

type
  PFarDialogItem = ^TFarDialogItem;
  TFarDialogItem = record
    Typ: (
      DI_TEXT,
      DI_VTEXT,
      DI_SINGLEBOX,
      DI_DOUBLEBOX,
      DI_EDIT,
      DI_PSWEDIT,
      DI_FIXEDIT,
      DI_BUTTON,
      DI_CHECKBOX,
      DI_RADIOBUTTON);
    X1, Y1,
    X2, Y2: Integer;
    Focus: LongBool;
    Selected: Integer;
    Flags: Cardinal;
    DefaultButton: LongBool;
    Data: array[0..Pred(512)] of Char;
  end;
  PFarDialogItemsArray = ^TFarDialogItemsArray;
  TFarDialogItemsArray = array[0..100] of TFarDialogItem;

  TFarMenuItem = record
    Text: array[0..Pred(128)] of Char;
    Selected, Checked, Separator: LongBool;
  end;
  PFarMenuItemsArray = ^TFarMenuItemsArray;
  TFarMenuItemsArray = array[0..0] of TFarMenuItem;

  FARAPIGETMSG = function(
    PluginNumber: Integer;
    MsgId: Integer): PChar;
    stdcall export;

  FARAPICONTROL = function(
    hPlugin: THandle;
    Command: FCTL;
    Param: Pointer): Boolean;
    stdcall export;

  FARAPIDIALOG = function(
    PluginNumber: Integer;
    X1, Y1,
    X2, Y2: Integer;
    HelpTopic: PChar;
    Item: PFarDialogItemsArray;
    ItemsNumber: Integer): Integer;
    stdcall export;

  FARAPIMENU = function(
    PluginNumber: Integer;
    X, Y: Integer;
    MaxHeight: Integer;
    Flags: Cardinal;
    Title, Bottom: PChar;
    HelpTopic: PChar;
    BreakKeys, BreakCode: PInteger;
    Item: PFarMenuItemsArray;
    ItemsNumber: Integer): Integer;
    stdcall export;

const
  FMSG_NORMAL = 0;
  FMSG_WARNING = 1;
  FMSG_ERRORTYPE = 2;
  FMSG_KEEPBACKGROUND = 4;
  FMSG_DOWN = 8;

type
  FARAPIMESSAGE = function(
    PluginNumber: Integer;
    Flags: DWORD;
    HelpTopic: PChar;
    Items: PPCharArray;
    ItemsNumber: Integer;
    ButtonsNumber: Integer): Integer;
    stdcall export;

  FARAPISAVESCREEN = function(
    X1, Y1,
    X2, Y2: Integer): THandle;
    stdcall export;

  FARAPIRESTORESCREEN = procedure(
    hScreen: THandle);
    stdcall export;

  FARAPIVIEWER = function(
    FileName: PChar;
    Title: PChar;
    X1, Y1, X2, Y2: Integer;
    Flags: Cardinal): LongBool;
    stdcall export;

  TPluginStartupInfo = record
    StructSize: Integer;
    ModuleName: array[0..Pred(NM)] of Char;
    ModuleNumber: Integer;
    RootKey: PChar;
    Menu: FARAPIMENU;
    Dialog: FARAPIDIALOG; 
    Message: FARAPIMESSAGE;
    GetMsg: FARAPIGETMSG;
    Control: FARAPICONTROL;
    SaveScreen: FARAPISAVESCREEN;
    RestoreScreen: FARAPIRESTORESCREEN;
    GetDirList: Pointer; //FARAPIGETDIRLIST
    GetPluginDirList: Pointer; //FARAPIGETPLUGINDIRLIST
    FreeDirList: Pointer; //FARAPIFREEDIRLIST
    Viewer: FARAPIVIEWER;
    Editor: Pointer;  //FARAPIEDITOR
    CmpName: Pointer;  //FARAPICMPNAME
  end;

  TWin32FindData = record
    dwFileAttributes: DWORD;
    ftCreationTime: TFileTime;
    ftLastAccessTime: TFileTime;
    ftLastWriteTime: TFileTime;
    nFileSizeHigh: DWORD;
    nFileSizeLow: DWORD;
    dwReserved0: DWORD;
    dwReserved1: DWORD;
    cFileName: array[0..MAX_PATH - 1] of AnsiChar;
    cAlternateFileName: array[0..13] of AnsiChar;
  end;

  TPluginPanelItem = record
    FindData: TWin32FindData;
    PackSizeHigh: DWORD;
    PackSize: DWORD;                         
    Flags: DWORD;                            
    NumberOfLinks: DWORD;                    
    Description: PChar;
    Owner: PChar;
    CustomColumnData: PPCharArray;
    CustomColumnNumber: Integer;
    Reserved: array[0..Pred(4)] of DWORD;
  end;

  PPluginPanelItemsArray = ^TPluginPanelItemsArray;
  TPluginPanelItemsArray = array[0..0] of TPluginPanelItem;

  TInfoPanelLine = record
    Text: array[0..Pred(80)] of Char;
    Data: array[0..Pred(80)] of Char;
    Separator: LongBool;
  end;
  TInfoPanelLinesArray = array[0..0] of TInfoPanelLine;

  TPanelMode = record
    ColumnTypes: PChar;
    ColumnWidths: PChar;
    ColumnTitles: PPCharArray;
    FullScreen: LongBool;
    DetailedStatus: LongBool;
    AlignExtensions: LongBool;
    CaseConversion: LongBool;
    Reserved: array[0..Pred(4)] of DWORD;
  end;
  TPanelModesArray = array[0..0] of TPanelMode;

  TKeyBarTitles = record
    Titles, CtrlTitles, AltTitles, ShiftTitles: array[0..Pred(12)] of PChar;
  end;

  TOpenPluginInfo = record
    StructSize: Integer;
    Flags: DWORD;
    HostFile: PChar;
    CurDir: PChar;
    Format: PChar;
    PanelTitle: PChar;
    InfoLines: ^TInfoPanelLinesArray;
    InfoLinesNumber: Integer;
    DescrFiles: PPCharArray;
    DescrFilesNumber: Integer;
    PanelModesArray: ^TPanelModesArray;
    PanelModesNumber: Integer;
    StartPanelMode: Integer;
    StartSortMode: OPENPLUGININFO_SORTMODES;
    StartSortOrder: Integer;
    KeyBar: ^TKeyBarTitles;
  end;

  TPanelInfo = record
    PanelType: (PTYPE_FILEPANEL, PTYPE_TREEPANEL, PTYPE_QVIEWPANEL, PTYPE_INFOPANEL);
    Plugin: LongBool;
    PanelRect: TRect;
    PanelItems: PPluginPanelItemsArray;
    ItemsNumber: Integer;
    SelectedItems: PPluginPanelItemsArray;
    SelectedItemsNumber: Integer;
    CurrentItem: Integer;
    TopPanelItem: Integer;
    Visible: LongBool;
    Focus: LongBool;
    ViewMode: Integer;
    ColumnTypes: array[0..Pred(80)] of Char;
    ColumnWidths: array[0..Pred(80)] of Char;
    CurDir: array[0..Pred(NM)] of Char;
    Reserved: array[0..Pred(4)] of DWORD;
  end;

var
  Info: TPluginStartupInfo;
  OnStartupInfoLoad: procedure;

function GetMsg(MsgId: TMessageNumber): PChar;
function Message(
  Flags: DWORD;
  HelpTopic: PChar;
  AItems: array of const;
  ButtonsNumber: Integer): Integer;

function Dialog(
  HelpTopic: PChar;
  AItems: array of const): Boolean;

procedure HandleException;

implementation

uses
  SysUtils;

procedure SetStartupInfo(var AInfo: TPluginStartupInfo)
  stdcall export;
begin
  Info := AInfo;

  if Assigned(OnStartupInfoLoad) then
    OnStartupInfoLoad;
end;


function GetMsg; 
begin
  with Info do
    Result := GetMsg(ModuleNumber, Integer(MsgId));
end;

function Message;
var
  Items: PPCharArray;
  ItemsNumber: Integer;
  I: Integer;
begin
  ItemsNumber := High(AItems)+1;
  GetMem(Items, SizeOf(PChar)*ItemsNumber);

  for I := 0 to High(AItems) do
    with AItems[I] do
      case VType of
        vtInteger: Items^[I] := GetMsg(TMessageNumber(VInteger));
        vtPChar: Items^[I] := VPChar;
        vtAnsiString: Items^[I] := VAnsiString;
        else{nil} Items^[I] := ' ';
      end;


  with Info do
    Result := Message(ModuleNumber,
      Flags,
      HelpTopic,
      Items,
      ItemsNumber,
      ButtonsNumber);

  FreeMem(Items);
end;

function Dialog;
var
  Items: PFarDialogItemsArray;
  ItemsNumber: Integer;
var
  CurrentItem: Integer;

  function Next: TVarRec;
  begin
    Result := AItems[CurrentItem];
    Inc(CurrentItem);
  end;

  procedure SetData;
  const
    ElementsPerItem = 8;
  var
    I: Integer;
    TotalElements: Integer;
    DefaultButtonNotAssigned: Boolean;
  begin
    TotalElements := High(AItems)+1;
    ItemsNumber := TotalElements div ElementsPerItem;
    GetMem(Items, SizeOf(TFarDialogItem)*ItemsNumber);

    CurrentItem := 0;
    DefaultButtonNotAssigned := True;
    for I := 0 to Pred(ItemsNumber) do
      with Items^[I] do
      begin
        Integer(Typ) := Next.VInteger;
        X1 := Next.VInteger; Y1 := Next.VInteger;
        X2 := Next.VInteger; Y2 := 0;
        Focus := Next.VBoolean;
        with Next do
          case VType of
            vtBoolean: Selected := Integer(VBoolean);  // 1
            vtPointer: Selected := Integer(Boolean(VPointer^)); //2  1,2  checkbox
            vtPChar: Selected := Integer(VPChar); // history
          end;
        Flags := Next.VInteger;
        DefaultButton := False;
        if Typ = DI_BUTTON then
        begin
          DefaultButton := DefaultButtonNotAssigned;
          DefaultButtonNotAssigned := False;
        end;
        with Next do
        begin
          FillChar(Data, SizeOf(Data), 0);
          case VType of
            vtInteger: StrCopy(Data, GetMsg(TMessageNumber(VInteger)));
//            vtPChar: StrCopy(Data, VPChar);
//            vtAnsiString: StrCopy(Data, VAnsiString);
            vtPointer: if Assigned(VPointer) then StrCopy(Data, PChar(PString(VPointer)^));
          end;
        end;
      end;
  end;

  procedure GetData;
  var
    I: Integer;
  begin
    CurrentItem := 0;
    for I := 0 to Pred(ItemsNumber) do
      with Items^[I] do
      begin
        {Integer(Typ) := }Next{.VInteger};
        {X1 := }Next{.VInteger}; {Y1 := }Next{.VInteger};
        {X2 := }Next{.VInteger}; {Y2 := 0;}
        {Focus := }Next{.VBoolean};
        with Next do
          case VType of
{            vtBoolean: Selected := VBoolean;}
            vtPointer: Boolean(VPointer^) := Boolean(Selected);
          end;
        {Flags := }Next{.VInteger};
        with Next do
          case VType of
//            vtInteger: StrCopy(Data, GetMsg(TMessageNumber(VInteger)));
//            vtPChar: StrCopy(Data, VPChar);
//            vtAnsiString: StrCopy(Data, VAnsiString);
            vtPointer: if Assigned(VPointer) then PString(VPointer)^ := Data;
//            else{nil} FillChar(Data, SizeOf(Data), 0);
          end;
      end;

    FreeMem(Items);
  end;

  function FirstButtonIndex: Integer;
  var
    I: Integer;
  begin
    for I := 0 to Pred(ItemsNumber) do
      if Items[I].Typ = DI_BUTTON then
      begin
        Result := I;
        Exit;
      end;
    Result := 0;
  end;

var
  FirstX,
  LastY: Integer;
begin
  SetData;

  FirstX := Items^[0].X2;
  LastY := Items^[Pred(ItemsNumber)].Y1;

  with Items^[0] do
  begin
    Y1 := 1;
    Y2 := LastY+1;
  end;                                     
  with Info do
    Result := Dialog(ModuleNumber,
      -1, -1,
      FirstX+2*2, LastY+3,
      HelpTopic,
      Items,
      ItemsNumber) = FirstButtonIndex{OK};

  if Result then
    GetData;
end;

procedure HandleException;
var
  Items: PPCharArray;
  ItemsNumber: Integer;

  procedure Add(P: PChar);
  begin
    ReAllocMem(Items, SizeOf(PChar)*(ItemsNumber+1));
    Items^[ItemsNumber] := P;
    Inc(ItemsNumber);
  end;

var
  Buffer: array[0..1023] of Char;
  P, BeginP: PChar;
begin
  ExceptionErrorMessage(ExceptObject, ExceptAddr, Buffer, SizeOf(Buffer));

  P := @Buffer;
  while P^ <> #0 do
  begin
    if P^ = #$A then
      P^ := ' ';

    Inc(P);
  end;

  Items := nil;
  ItemsNumber := 0;

  Add(PChar(SExceptTitle));

  P := @Buffer;
  BeginP := P;
  while P^ <> #0 do
    if (P^ = '.') and (P[1] = ' ')
    then
    begin
      P^ := #0;
      Add(BeginP);
      Inc(P, 2);
      BeginP := P;
    end
    else
      Inc(P);

  Add(BeginP);
  Add(GetMsg(MOK));

  Info.Message(
    Info.ModuleNumber,
    FMSG_WARNING,
    'Exception',
    Items,
    ItemsNumber,
    1);

  FreeMem(Items);
end;


exports
  SetStartupInfo;

end.
