(*
 :
   -------------1.4
   1.     ' '+s+' ' - ?   title  { s }   {c:\temp}
   ( )
   2.        FAR   
        ,  description'   
   ( )
   3.  .hlp . GetPluginInfo  :
      void WINAPI GetPluginInfo(
        HANDLE hPlugin,
        struct PluginInfo *Info
      );
               - Info.
   ( )
   4.  .hlf     far*.hlf
   ( ,     ':')
   5.  PutFiles        
           ?
   ( )
   6. SetDirectory    ,      
       far'         /
         .     plugin?
       , - ,     
   ( )
   7.  Alt+F7  plugin'       
   ( )
   8.  .hlp :  DI_RADIOBOX,    DI_RADIOBUTTON
   ()
   9.  GetOpenPluginInfo  CurDir     '\'  ,     ..
   (,   -   )
  10.    ^f3,   -   viewer
  ( !)
  11.    ClosePlugin?   ,  ...
  ( ! ProcessEvent(FE_CLOSE  Result = False))
  12.    OPIF_REALNAMES   Get/Put_Files.
        CD   .TDR .   .TDR,   CD.
  ( !)
  13.  GetVirtualFindData    descriptions.
  ( !)
  14.  .ClosePlugin  .Control(... updateAnotherPanel),    another -
      ,     (plugin'),    .control, 
       gpf,    -  getvirtualfinddata
  ( ,      ProcessEvent(FE_CLOSE),   )
  15.      - plugin,  f5    ,
         - ,  
  ( )
  16.   .hlf topic'  16  -
       NT  ,   95   dialog' -
        
  (,  ,  )

   !
  -------------------1.5
  1. FE_CLOSE  ,    ..
  2.  Alt+F7   OPIF_REALNAMES  ...
  3. GetVirtualFindData  Description, ,  
  4. F3    OPIF_EXTERNALGET   ,  
  5.   grab   ctrl+z,   getpanelinfo.panelitems.description
     !
  6.         KeyBar
     , , GetOpenPluginInfo 
  7.    [Shift+F2]  OPIF_REALNAMES
*)

library PAFTDR;

{.$D-     break'  begin  .    ? step prog block off...}

uses
  Windows,
  SysUtils,
  ConfigU in 'ConfigU.pas',
  PluginU in 'PluginU.pas',
  FARIntf in 'FARIntf.pas',
  FARLang in 'FARLang.pas',
  Common in 'Common.pas',
  TapeLevelU in 'TapeLevelU.pas',
  RootLevelU in 'RootLevelU.pas',
  LevelU in 'LevelU.pas';

{$R *.RES}

function OpenPlugin(
  OpenFrom: OPEN;
  Item: Integer): THandle
  stdcall export;
begin
  Result := INVALID_HANDLE_VALUE;

  try
    Result := THandle(TPlugin.Create(''));
  except
    HandleException;
  end;
end;

function OpenFilePlugin(
  const Name: PChar;
  var Data;
  DataSize: Integer): THandle
  stdcall export;
begin
  Result := INVALID_HANDLE_VALUE;

  try
    if TPlugin.IsOurs(Name, Data, DataSize) then
      Result := THandle(TPlugin.Create(Name));
  except
    HandleException;
  end;
end;

procedure ClosePlugin(
  hPlugin: THandle);
  stdcall export;
begin
  try
    TPlugin(hPlugin).Free;
  except
    HandleException;
  end;
end;


procedure GetPluginInfo(
  var Info: TPluginInfo);
  stdcall export;
begin
  try
    TPlugin.GetPluginInfo(Info);
  except
    HandleException;
  end;
end;


procedure GetOpenPluginInfo(
  hPlugin: THandle;
  var Info: TOpenPluginInfo);
  stdcall export;
begin
  try
    TPlugin(hPlugin).Level.GetOpenPluginInfo(Info);
  except
    HandleException;
  end;
end;

function SetDirectory(
  hPlugin: THandle;
  Dir: PChar;
  OpMode: Integer): LongBool;
  stdcall export;
begin
  Result := False;

  try
    Result := TPlugin(hPlugin).SetFolder(
      Dir,
      OpMode);
  except
    HandleException;
  end;
end;

function GetFindData(
  hPlugin: THandle;
  var PanelItems: PPluginPanelItemsArray;
  var ItemsNumber: Integer;
  OpMode: Integer): LongBool;
  stdcall export;
begin
  Result := False;

  try
    Result := TPlugin(hPlugin).Level.GetFindData(
      PanelItems,
      ItemsNumber,
      OpMode);
  except
    HandleException;
  end;
end;

procedure FreeFindData(
  hPlugin: THandle;
  PanelItems: PPluginPanelItemsArray;
  ItemsNumber: Integer);
  stdcall export;
begin
  try
    TLevel.FreeFindData(
      PanelItems,
      ItemsNumber);
  except
    HandleException;
  end;
end;

function ProcessEvent(
  hPlugin: THandle;
  Event: FE;
  Param: Pointer): LongBool;
  stdcall export;
begin
  Result := False;

  try
    Result := TPlugin(hPlugin).ProcessEvent(Event, Param);
  except
    HandleException;
  end;
end;

function ProcessKey(
  hPlugin: THandle;
  Key: Integer;
  ControlState: Integer): LongBool; // long    , ,   ...
  stdcall export;
begin
  Result := False;

  try
    Result := TPlugin(hPlugin).Level.ProcessKey(Key, ControlState);
  except
    HandleException;
  end;
end;

function Configure(
  ItemNumber: Integer): LongBool;
  stdcall export;
begin
  Result := False;

  try
    Result := Config(ItemNumber);
  except
    HandleException;
  end;
end;

function PutFiles(
  hPlugin: THandle;
  PanelItems: PPluginPanelItemsArray;
  ItemsNumber: Integer;
  Move: LongBool;
  OpMode: Integer): LongBool;
  stdcall export;
begin
  Result := False;

  try
    Result := TPlugin(hPlugin).Level.PutFiles(
      PanelItems,
      ItemsNumber,
      Move,
      OpMode);
  except
    HandleException;
  end;
end;

function GetFiles(
  hPlugin: THandle;
  PanelItems: PPluginPanelItemsArray;
  ItemsNumber: Integer;
  Move: LongBool;
  DestPath: PChar;
  OpMode: Integer): LongBool;
  stdcall export;
begin
  Result := False;

  try
    Result := TPlugin(hPlugin).Level.GetFiles(
      PanelItems,
      ItemsNumber,
      Move,
      DestPath,
      OpMode);
  except
    HandleException;
  end;
end;

function GetVirtualFindData(
  hPlugin: THandle;
  var PanelItems: PPluginPanelItemsArray;
  var ItemsNumber: Integer;
  Path: PChar): LongBool;
  stdcall export;
begin
  Result := False;

  try
    Result := TPlugin(hPlugin).GetVirtualFindData(
      PanelItems,
      ItemsNumber,
      Path);
  except
    HandleException;
  end;
end;

procedure FreeVirtualFindData(
  hPlugin: THandle;
  PanelItems: PPluginPanelItemsArray;
  ItemsNumber: Integer);
  stdcall export;
begin
  try
    TLevel.FreeVirtualFindData(
      PanelItems,
      ItemsNumber);
  except
    HandleException;
  end;
end;

function MakeDirectory(
  hPlugin: THandle;
  Name: PChar;
  OpMode: Integer): Integer;
  stdcall export;
begin
  Result := -1;

  try
    Result := TPlugin(hPlugin).Level.MakeFolder(
      Name,
      OpMode);
  except
    HandleException;
  end;
end;

exports
  OpenPlugin,
  OpenFilePlugin,
  ClosePlugin,
  GetPluginInfo,
  GetOpenPluginInfo,
  SetDirectory,
  GetFindData,
  FreeFindData,
  ProcessEvent,
  ProcessKey,
  Configure,
  PutFiles,
  GetFiles,
  GetVirtualFindData,
  FreeVirtualFindData,
  MakeDirectory;

begin
end.
